# Description

The `SqlConfiguration` DSC resource manages the [SQL Server Configuration Options](https://msdn.microsoft.com/en-us/library/ms189631.aspx)
on a SQL Server instance.

To list the available configuration option names run:

```powershell
$serverObject = Connect-SqlDscDatabaseEngine -InstanceName 'SQL2022'
$serverObject | Get-SqlDscConfigurationOption | ft
```

## Requirements

* Target machine must be running Windows Server 2012 or later.
* Target machine must be running SQL Server Database Engine 2012 or later.

## Known issues

All issues are not listed here, see [here for all open issues](https://github.com/dsccommunity/SqlServerDsc/issues?q=is%3Aissue+is%3Aopen+in%3Atitle+SqlConfiguration).
